'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.update = exports.destroy = exports.create = exports.get = undefined;

var _error = require('../error');

var _error2 = _interopRequireDefault(_error);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

let prefix;
let defaultConfig;

exports.default = (server, a, b, names, options) => {
  prefix = options.prefix;
  defaultConfig = options.defaultConfig;

  get(server, a, b, names);
  create(server, a, b, names);
  destroy(server, a, b, names);
  update(server, a, b, names);
};

const get = exports.get = (server, a, b, names) => {
  var _desc, _value, _obj;

  server.route((_obj = {
    method: 'GET',
    path: `${ prefix }/${ names.a.singular }/{aid}/${ names.b.singular }`,

    handler(request, reply) {
      return _asyncToGenerator(function* () {
        const include = (0, _utils.parseInclude)(request);
        const where = (0, _utils.parseWhere)(request);

        const base = yield a.findOne({
          where: {
            [a.primaryKeyField]: request.params.aid
          }
        });
        const method = (0, _utils.getMethod)(base, names.b, false);

        const list = yield method({ where, include, limit: 1 });

        if (Array.isArray(list)) {
          reply(list[0]);
        } else {
          reply(list);
        }
      })();
    },

    config: defaultConfig
  }, (_applyDecoratedDescriptor(_obj, 'handler', [_error2.default], Object.getOwnPropertyDescriptor(_obj, 'handler'), _obj)), _obj));
};

const create = exports.create = (server, a, b, names) => {
  var _desc2, _value2, _obj2;

  server.route((_obj2 = {
    method: 'POST',
    path: `${ prefix }/${ names.a.singular }/{id}/${ names.b.singular }`,

    handler(request, reply) {
      return _asyncToGenerator(function* () {
        const base = yield a.findOne({
          where: {
            [a.primaryKeyField]: request.params.id
          }
        });

        const method = (0, _utils.getMethod)(base, names.b, false, 'create');
        const instance = yield method(request.payload);

        reply(instance);
      })();
    },

    config: defaultConfig
  }, (_applyDecoratedDescriptor(_obj2, 'handler', [_error2.default], Object.getOwnPropertyDescriptor(_obj2, 'handler'), _obj2)), _obj2));
};

const destroy = exports.destroy = (server, a, b, names) => {
  var _desc3, _value3, _obj3;

  server.route((_obj3 = {
    method: 'DELETE',
    path: `${ prefix }/${ names.a.singular }/{aid}/${ names.b.singular }/{bid}`,

    handler(request, reply) {
      return _asyncToGenerator(function* () {
        const include = (0, _utils.parseInclude)(request);
        const where = (0, _utils.parseWhere)(request);

        const base = yield a.findOne({
          where: {
            [a.primaryKeyField]: request.params.aid
          }
        });

        where[b.primaryKeyField] = request.params.bid;

        const method = (0, _utils.getMethod)(base, names.b, false, 'get');
        const instance = yield method({ where, include });
        yield instance.destroy();

        reply(instance);
      })();
    },

    config: defaultConfig
  }, (_applyDecoratedDescriptor(_obj3, 'handler', [_error2.default], Object.getOwnPropertyDescriptor(_obj3, 'handler'), _obj3)), _obj3));
};

const update = exports.update = (server, a, b, names) => {
  var _desc4, _value4, _obj4;

  server.route((_obj4 = {
    method: 'PUT',
    path: `${ prefix }/${ names.a.singular }/{aid}/${ names.b.singular }/{bid}`,

    handler(request, reply) {
      return _asyncToGenerator(function* () {
        const include = (0, _utils.parseInclude)(request);
        const where = (0, _utils.parseWhere)(request);

        const base = yield a.findOne({
          where: {
            id: request.params.aid
          }
        });

        where[b.primaryKeyField] = request.params.bid;

        const method = (0, _utils.getMethod)(base, names.b, false);

        const instance = yield method({ where, include });
        yield instance.update(request.payload);

        reply(instance);
      })();
    },

    config: defaultConfig
  }, (_applyDecoratedDescriptor(_obj4, 'handler', [_error2.default], Object.getOwnPropertyDescriptor(_obj4, 'handler'), _obj4)), _obj4));
};